<template>

    <div class="main" id="inicio">
        <h1 style="margin-top: 30px"><b>Viagens do Dia:</b></h1>
        <div style="text-align: center; margin-top: 2vw">
            <table class="table" style="margin-top: 8vw">
                <thead class="thead-danger">
                    <tr class="table-primary">
                        <th>ID</th>
                        <th>Destino</th>
                        <th>Origem</th>
                        <th>Data de Saída</th>
                        <th>Data de Retorno</th>
                        <th>Horário de Saída</th>
                        <th>N° Passageiros</th>
                        <th>N° Motoristas</th>
                        <th>Ações</th>
                    </tr>
                </thead>
                <tbody>
                  <tr v-for="viagem of viagens" :key="viagem.id">
                    <td>{{ viagem.id }}</td>
                    <td>{{ viagem.origem }}</td>
                    <td>{{ viagem.destino }}</td>
                    <td>{{ viagem.data_s }}</td>
                    <td>{{ viagem.data_r }}</td>
                    <td>{{ viagem.hora_s }}</td>
                    <td>{{ viagem.passageiros.length }}</td>
                    <td>{{ viagem.motoristas.length }}</td>
                    <td id="botao"> 
                      <router-link v-bind:to="'/viagem_add_motorista/' + viagem.id"><button type="button" id="botao" class="btn btn-primary" style="text-align: center; margin: 3px">Motoristas</button></router-link> &nbsp 
                      <router-link v-bind:to="'/viagem_add_passageiros/' + viagem.id"><button type="button" id="botao" class="btn btn-warning">Passageiros</button></router-link>
                    </td>
                  </tr>
                </tbody>
            </table>
            <button type="button" @click="relatorioDia()" class="btn btn-success">Relatório do Dia</button>
        </div>
    </div>

    
</template>


<script>
  import Viagem from '../services/viagens'
  import axios from 'axios'
  import { httpGet } from '../services/config'

  import jsPDF from 'jspdf';
  import autoTable from 'jspdf-autotable';

  export default {
    
    data(){
      return{
        viagem: {
          id: '',
          dist_pre: '',
          dist_real: '',
          origem: '',
          origem_estado: '',
          destino: '',
          destino_estado: '',
          orcamento: '',
          data_s: '',
          hora_s: '',
          data_r: ''
        },
        viagens: [],
        errors: [],
        
      }
    },

    mounted (){
        this.listar()
    },

    methods:{

      listar(){
        Viagem.listar().then(resposta => {
            let viagens = resposta.data;
            let viagens_dia = [];
            let date = new Date;
            let data = 
                date.getFullYear() +
                "-" + ("00" + Number(date.getMonth()+1)).slice(-2) +
                "-" + ("00" + date.getDate()).slice(-2);
            for(let i = 0; i < viagens.length; i++) {
                if (viagens[i].data_s == data) {
                    viagens_dia.push(viagens[i]);
                }
            }
            this.viagens = viagens_dia;
        })
      },
      relatorioDia (){
        let viagens_dia = [];
        let soma_orcamento = 0;
        for (let index = 0; index < this.viagens.length; index++) {
          let v = {
            id: this.viagens[index].id,
            origem: this.viagens[index].origem,
            destino: this.viagens[index].destino,
            orcamento: "R$ " + this.viagens[index].orcamento.toFixed(2),
            data_s: this.viagens[index].data_s,
            hora_s: this.viagens[index].hora_s,
            data_r: this.viagens[index].data_r,
            n_p: this.viagens[index].passageiros.length,
            n_m: this.viagens[index].motoristas.length
          };
          soma_orcamento += this.viagens[index].orcamento;
          viagens_dia.push(v);
        }
        
        let doc = new jsPDF();
        doc.setFontSize(22);
        doc.text('Viagens do Dia', 79, 12);
        doc.setFontSize(16);
        doc.text('Samba Viagens', 85, 20);
        doc.setFontSize(12);
        let date = new Date;
        let data = ("00" + date.getDate()).slice(-2)+
                    "/"+("00" + Number(date.getMonth()+1)).slice(-2)+
                    "/"+date.getFullYear();
        let hora = ("00"+date.getHours()).slice(-2)+
                    ":"+("00"+date.getMinutes()).slice(-2)+
                    ":"+("00"+date.getSeconds()).slice(-2);
        doc.text('Data: '+data+'  Hora: '+hora, 72, 27);
        doc.setFontSize(10);
        doc.text('Total de Orçamento: R$ '+soma_orcamento.toFixed(2), 15, 38);
        doc.text('Total de Viagens: '+viagens_dia.length, 15, 45);
        doc.autoTable({
          head: [
            {id: '#', 
            destino: 'Destino', 
            origem: 'Origem',
            orcamento: 'Orçamento',
            data_s: 'Saida',
            data_r: 'Retorno',
            hora_s: 'Hora de Saida',
            n_p: 'Passageiros',
            n_m: 'Motoristas'}
          ],
          body: viagens_dia,
          startY: 50,
          /* apply styling to table body */
          bodyStyles: {
              valign: 'top'
          },
          /* apply global styling */
          styles: {
              cellWidth: 'wrap',
              rowPageBreak: 'auto',
              halign: 'justify',
          },
          /* apply styling specific to table columns */
          columnStyles: {
              text: {
                  cellWidth: 'auto'
              }
          }
        });
        doc.output('dataurlnewwindow', "SambaOnibus_ViagensDia.pdf");
      },
    }
  }
</script>

<style>
  #inicio {
    background: url('../assets/calendar-icon.png');
    background-repeat: no-repeat;
    background-size: 120px;
  }

  h1 {
    text-align: center;
  }
</style>
